/**
Palindrome detector

Examples:
able was i ere i saw elba
racecar
**/

#include <iostream>
#include <string>
using namespace std;


bool isPalindrome(string input, string indent = "")
{
    bool result;
    string in = input;
    cout << indent << in << endl;

    // why don't we use == 1 ?
    if(in.length() <= 1)
    {
        result = true;
    }
    else
    {
        // what happens for an almost palindrome (middle mismatch)
        result = ((in[0] == in[in.length() - 1]) &&
                  isPalindrome(input.substr(1, in.length() - 2),
                               indent += " "));

        cout << indent << in << endl;
    }

    return result;
}

int main()
{
    cout << "Enter a palindrome: " << endl;
    string input;
    getline(cin, input);

    if(isPalindrome(input))
    {
        cout << "That is a palindrome" << endl;
    }
    else
    {
        cout << "That is NOT a palindrome" << endl;
    }

    return 0;
}
